require "james_bond/core/mission"
require "james_bond/mission_kubernetes/config"
require "james_bond/mission_kubernetes/build_handler"

module JamesBond
  class KubernetesBuildMission
    include JamesBond::Core::Mission

    MISSION_NAME            = "kubernetes"
    MISSION_MAIN_COMMANDS   = ["build"]
    CONFIGURATION_FILE_PATH = File.join(Dir.pwd, "config", "james_bond", "kubernetes.yml")

    def build(config, params)
      config.name          = MISSION_NAME
      config.main_commands = MISSION_MAIN_COMMANDS
      arguments_parser do |parser|
        parser.banner =  "bond #{MISSION_MAIN_COMMANDS[0]} [options]"
        parser.string  "-t", "--tag",
          "Creates a docker image with the specified tag. If omitted a tag " + \
          "like devel-212121 will be generated automaticaly."
      end
    end

    def run_build_command(command:, mission_pool:)
      self.class::BuildHandler.new(command, config_file).run
    end

    def config_file
      @config_file ||= self.class::Config.new(yaml_path: CONFIGURATION_FILE_PATH)
    end
  end
end
