require "open3"
require "json"

module JamesBond
  class MissionKubernetes
    class BuildHandler
      attr_accessor :config

      def initialize(command, config)
        @command = command
        @config  = config.for(env: command.env, command: command.main_command)
      end

      def run
        target = "#{config["image_name"]}:#{tag}"
        command = "docker build -t #{target} ."

        Open3.popen3(command) do |stdin, stdout, stderr, thread|
          Thread.new do
            until (line = stdout.gets).nil? do
              puts line
            end
          end

          thread.join
        end

        { tag: tag }
      end

      def tag
        options = @command.options
        time_tag = "devel-#{Time.now.to_i}"
        @tag ||= if options && options[:tag]
                   options[:tag]
                 else
                   time_tag
                 end
      end
    end
  end
end
