require "yaml"

module JamesBond
  class MissionKubernetes
    class Config
      attr_accessor :yaml_path,
                    :raw_hash

      def initialize(yaml_path:)
        @yaml_path = yaml_path
        extract_config_from_yaml(@yaml_path)
      end


      def for(env:,command:)
        env_config = @raw_hash[env]
        raise "No config for '#{env}' environment" if !env_config

        commands = env_config.fetch("commands", proc { raise_error(command, env)} )
        commands.fetch(command, proc { raise_error(command, env) })
      end

      private

      def raise_error(command, env)
        raise "No config for '#{command}' command in '#{env}' environment"
      end

      def extract_config_from_yaml(yaml_path)
        @raw_hash = YAML.load(File.read(yaml_path)).freeze
      end
    end
  end
end
